if select(2, UnitClass("player")) ~= "PRIEST" then return end
local GetSpellInfo = GetSpellInfo
local UnitExists = UnitExists
local UnitIsFriend = UnitIsFriend
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax

function DrDamage:PlayerData()
	--Health Updates
	self.TargetHealth = { [1] = 0.501, [2] = 0.351, [0.351] = GetSpellInfo(32379) }
	--General
	self.Calculation["PRIEST"] = function ( calculation, ActiveAuras, Talents )
		if ActiveAuras["Shadowform"] then
			calculation.dmgM = calculation.dmgM * 1.15
		end
	end
	--Talents
	local da = GetSpellInfo(47515)
	self.Calculation["Divine Aegis"] = function( calculation, value )
		if calculation.canCrit then
			calculation.extraCrit = value * ((self:GetSetAmount( "Tier 9 - Healing" ) >= 4) and 1.1 or 1)
			calculation.extraChanceCrit = true
			calculation.extraName = da
		end
	end
	self.Calculation["Improved Flash Heal"] = function( calculation, value )
		local target = not UnitExists("target") and "player" or UnitIsFriend("target","player") and "target" or UnitIsFriend("targettarget","player") and "targettarget"
		if target and UnitHealth(target) ~= 0 and (UnitHealth(target) / UnitHealthMax(target)) <= 0.5 then
			calculation.critPerc = calculation.critPerc + value
		end
	end
	self.Calculation["Test of Faith"] = function( calculation, value )
		local target = not UnitExists("target") and "player" or UnitIsFriend("target","player") and "target" or UnitIsFriend("targettarget","player") and "targettarget"
		if target and UnitHealth(target) ~= 0 and (UnitHealth(target) / UnitHealthMax(target)) <= 0.5 then
			calculation.dmgM = calculation.dmgM * (1 + value)
		end
	end	
	
	--Spells
	self.Calculation["Mind Blast"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadow Word: Pain"] and BuffTalentRanks["Twisted Faith"] then
 			calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Twisted Faith"])
		end
	end
	self.Calculation["Mind Flay"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadow Word: Pain"] and BuffTalentRanks["Twisted Faith"] then
			--Glyph of Shadow Word: Pain
 			calculation.dmgM = calculation.dmgM * (1 + BuffTalentRanks["Twisted Faith"] + (self:HasGlyph(55687) and 0.1 or 0))
		end
	end
	self.Calculation["Shadow Word: Pain"] = function ( calculation, ActiveAuras )
		if ActiveAuras["Shadowform"] then
			calculation.canCrit = true
			calculation.critM = calculation.critM + 0.5
		end
	end
	self.Calculation["Vampiric Touch"] = self.Calculation["Shadow Word: Pain"]
	self.Calculation["Devouring Plague"] = function ( calculation, ActiveAuras, BuffTalentRanks )
		if ActiveAuras["Shadowform"] then
			calculation.canCrit = true
			calculation.critM = calculation.critM + 0.5
		end
		if BuffTalentRanks["Improved Devouring Plague"] then
			calculation.dmgM_dd = BuffTalentRanks["Improved Devouring Plague"]
			calculation.hybridDotDmg = (calculation.minDam + calculation.maxDam) / 2
			calculation.spellDmgM_dot = calculation.spellDmgM
			calculation.canCrit = true
		end		
	end
	self.Calculation["Renew"] = function ( calculation, _, BuffTalentRanks )
		--Glyph of Renew
		if self:HasGlyph(55674) then
			calculation.eDuration = calculation.eDuration - 3
		end
		if BuffTalentRanks["Empowered Renew"] then
			calculation.dmgM_dd = BuffTalentRanks["Empowered Renew"] * (1 + (BuffTalentRanks["Twin Disciplines"] or 0))
			if self:GetSetAmount( "Tier 9 - Healing" ) >= 4 then
				calculation.dmgM_dd = calculation.dmgM_dd * 1.1
			end	
			calculation.hybridDotDmg = ((calculation.minDam + calculation.maxDam) / 2)
			calculation.spellDmgM_dot = calculation.spellDmgM
			calculation.canCrit = true			
			--Custom damage modifier for blessed resilience double stacking for empowered renew direct heal part
			calculation.dmgM_custom = true
			local dmgM_dot = calculation.dmgM_dot * calculation.dmgM * (1 + calculation.dmgM_Add + calculation.dmgM_dot_Add)
			calculation.dmgM_Add = calculation.dmgM_Add + (BuffTalentRanks["Blessed Resilience"] or 0)
			calculation.dmgM = calculation.dmgM_dot * calculation.dmgM * (1 + calculation.dmgM_Add + calculation.dmgM_dot_Add)
			calculation.dmgM_dot = dmgM_dot
		end
	end
	self.Calculation["Holy Nova"] = function( calculation )
		--Glyph of Holy Nova
		if self:HasGlyph(55683) then
			if calculation.healingSpell then
				calculation.dmgM = calculation.dmgM * 1.4
			else
				calculation.dmgM = calculation.dmgM * 0.6
			end
		end
	end
	self.Calculation["Lightwell"] = function( calculation, _, Talents )
		--Glyph of Lightwell
		if self:HasGlyph(55673) then
			calculation.dmgM = calculation.dmgM * 1.2
		end
		if Talents["Blessed Resilience"] then
			calculation.dmgM = calculation.dmgM /(1 + Talents["Blessed Resilience"])
		end
	end
	self.Calculation["Shadow Word: Death"] = function( calculation )
		--Glyph of Shadow Word: Death
		if self:HasGlyph(55682) then
			if UnitHealth("target") ~= 0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.35 then
				calculation.dmgM = calculation.dmgM * 1.1
			end
		end
	end
	self.Calculation["Smite"] = function( calculation, ActiveAuras, BuffTalentRanks )
		--Glyph of Smite
		if self:HasGlyph(55692) and ActiveAuras["Holy Fire"] then
 			calculation.dmgM = calculation.dmgM * 1.2
		end
	end
	self.Calculation["Prayer of Healing"] = function( calculation, _, _, spell, baseSpell )
		--Glyph of Prayer of Healing
		if self:HasGlyph(55680) then
			calculation.hybridDotDmg = 0.2 * calculation.dmgM * (1 + calculation.dmgM_Add) * (calculation.spellDmgM * calculation.spellDmg + (calculation.minDam + calculation.maxDam)/2)
			calculation.spellDmgM_dot = 0
			calculation.eDuration = 6
			calculation.sTicks = 3
		end
	end
	local glyph = GetSpellInfo(52817)
	self.Calculation["Power Word: Shield"] = function( calculation, _, Talents )
		--Glyph of Power Word: Shield
		if self:HasGlyph(55672) then
			calculation.extraCrit = 0.2 * (1 + (Talents["Focused Power"] or 0))
			calculation.extraCanCrit = true
			calculation.extraName = glyph
			if Talents["Divine Aegis Bonus"] then
				--calculation.extraName = calculation.extraName .. "+" .. da
				calculation.extraCritEffect = (1 + Talents["Divine Aegis Bonus"]) * ((self:GetSetAmount( "Tier 9 - Healing" ) >= 4) and 1.1 or 1)
			end			
		end
	end	
	
	--Set bonuses
	
	--Sets
	self.SetBonuses["Tier 7 - Damage"] = { 40454, 40456, 40457, 40458, 40459, 39521, 39523, 39528, 39529, 39530 }
	self.SetBonuses["Tier 7 - Healing"] = { 40445, 40447, 40448, 40449, 40450, 39514, 39515, 39517, 39518, 39519  }
	self.SetBonuses["Tier 8 - Damage"] = { 46163, 46165, 46168, 46170, 46172, 45391, 45392, 45393, 45394, 45395 }
	self.SetBonuses["Tier 8 - Healing"] = { 46188, 46190, 46193, 46195, 46197, 45386, 45387, 45388, 45389, 45390 }
	self.SetBonuses["Tier 9 - Damage"] = { 48072, 48073, 48074, 48075, 48076, 48097, 48098, 48099, 48100, 48101, 48078, 48077, 48081, 48079, 48080, 48085, 48086, 48082, 48084, 48083, 48095, 48096, 48092, 48094, 48093, 48088, 48087, 48091, 48089, 48090 }
	self.SetBonuses["Tier 9 - Healing"] = { 47914, 47936, 47980, 47981, 47982, 48067, 48068, 48069, 48070, 48071, 48065, 48066, 48064, 48063, 48062, 48058, 48057, 48059, 48060, 48061, 47984, 47983, 47985, 47986, 47987, 48035, 48037, 48033, 48031, 48029 }
	
	--Effects
	self.SetBonuses["Devouring Plague"] = function( calculation )
		if self:GetSetAmount( "Tier 8 - Damage" ) >= 2 then
			calculation.dmgM_custom = true
			local dmgM = calculation.dmgM_dot * calculation.dmgM * (1 + calculation.dmgM_Add + calculation.dmgM_dot_Add)
			calculation.dmgM_dot_Add = calculation.dmgM_dot_Add + 0.15
			calculation.dmgM_dot = calculation.dmgM_dot * calculation.dmgM * (1 + calculation.dmgM_Add + calculation.dmgM_dot_Add)
			calculation.dmgM = dmgM
		end	
	end
	self.SetBonuses["Prayer of Healing"] = function( calculation )
		if self:GetSetAmount( "Tier 8 - Healing" ) >= 2 then
			calculation.critPerc = calculation.critPerc + 10
		end	
	end
	self.SetBonuses["Shadow Word: Death"] = function( calculation )
		if self:GetSetAmount( "Tier 7 - Damage" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 10
		end	
	end
	self.SetBonuses["Prayer of Mending"] = function( calculation )
		if self:GetSetAmount( "Tier 7 - Healing" ) >= 2 then
			calculation.sHits = calculation.sHits + 1
		end	
		if self:GetSetAmount( "Tier 9 - Healing" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.2
		end	
	end	
	self.SetBonuses["Prayer of Mending"] = function( calculation )
		if self:GetSetAmount( "Tier 7 - Healing" ) >= 2 then
			calculation.sHits = calculation.sHits + 1
		end	
		if self:GetSetAmount( "Tier 9 - Healing" ) >= 2 then
			calculation.dmgM = calculation.dmgM * 1.2
		end	
	end	
	self.SetBonuses["Vampiric Touch"] = function( calculation )
		if self:GetSetAmount( "Tier 9 - Damage" ) >= 2 then
			calculation.eDuration = calculation.eDuration + 6
		end	
	end
	self.SetBonuses["Mind Flay"] = function( calculation )
		if self:GetSetAmount( "Tier 9 - Damage" ) >= 4 then
			calculation.critPerc = calculation.critPerc + 5
		end	
	end
	
	--AURAS
--Player
	--Shadowform
	self.PlayerAura[GetSpellInfo(15473)] = { School = "Shadow", ActiveAura = "Shadowform" }
	--Borrowed time
	self.PlayerAura[GetSpellInfo(59891)] = { Update = true }
	--Shadow Weaving
	self.PlayerAura[GetSpellInfo(15258)] =  { School = "Shadow", Value = 0.02, Apps = 5 }
--Target	
	--Grace
	self.TargetAura[GetSpellInfo(47516)] =  { School = "Healing", Value = 0.03, Apps = 3, SelfCastBuff = true }
	--Shadow Word: Pain
	self.TargetAura[GetSpellInfo(589)] = { ActiveAura = "Shadow Word: Pain" }
	--Holy Fire
	self.TargetAura[GetSpellInfo(14914)] = { Spells = GetSpellInfo(585), ActiveAura = "Holy Fire" }
	--Weakened Soul
	self.TargetAura[GetSpellInfo(6788)] = { Spells = { [GetSpellInfo(53007)] = true, [GetSpellInfo(2061)] = true, [GetSpellInfo(2060)] = true }, ModType = "Special" }
--Special aura handling	
	--Weakened Soul
	self.Calculation[GetSpellInfo(6788)] = function( calculation, _, Talents )
		if Talents["Renewed Hope"] and calculation.healingSpell then
			calculation.critPerc = calculation.critPerc + Talents["Renewed Hope"]
		end
	end
	
	--SPELLS
	self.spellInfo = {
		--TODO: Verify coeffs PW:S, Prayer of Mending, Desperate Prayer, Divine Hymn, (Lesser Heal, Heal)
		[GetSpellInfo(15407)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Mind Flay", 
					[0] = { School = "Shadow", canCrit = true, castTime = 3, bonusFactor = 0.771, sTicks = 1, Channeled = true },
					[1] = { 45, 45, spellLevel = 20, },
					[2] = { 108, 108, spellLevel = 28, },
					[3] = { 159, 159, spellLevel = 36, },
					[4] = { 222, 222, spellLevel = 44, },
					[5] = { 282, 282, spellLevel = 52, },
					[6] = { 363, 363, spellLevel = 60, },
					[7] = { 450, 450, spellLevel = 68, },
					[8] = { 492, 492, spellLevel = 74, },
					[9] = { 588, 588, spellLevel = 80, },
		},		
		[GetSpellInfo(2944)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Devouring Plague",
					[0] = { School = "Shadow", eDot = true, eDuration = 24, bonusFactor = 1.4792, Cooldown = 24, sTicks = 3, },
					[1] = { 152, 152, spellLevel = 20, },
					[2] = { 272, 272, spellLevel = 28, },
					[3] = { 400, 400, spellLevel = 36, },
					[4] = { 544, 544, spellLevel = 44, },
					[5] = { 712, 712, spellLevel = 52, },
					[6] = { 904, 904, spellLevel = 60, },
					[7] = { 1088, 1088, spellLevel = 68, },
					[8] = { 1144, 1144, spellLevel = 73, },
					[9] = { 1376, 1376, spellLevel = 79, },
		},
		[GetSpellInfo(589)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Shadow Word: Pain",
					[0] = { School = "Shadow", eDot = true, eDuration = 18 , bonusFactor = 1.0974, sTicks = 3 },
					[1] = { 30, 30, spellLevel = 4, },
					[2] = { 60, 60, spellLevel = 10, },
					[3] = { 120, 120, spellLevel = 18, },
					[4] = { 210, 210, spellLevel = 26, },
					[5] = { 330, 330, spellLevel = 34, },
					[6] = { 462, 462, spellLevel = 42, },
					[7] = { 606, 606, spellLevel = 50, },
					[8] = { 768, 768, spellLevel = 58, },
					[9] = { 906, 906, spellLevel = 65, },
					[10] = { 1116, 1116, spellLevel = 70, },
					[11] = { 1176, 1176, spellLevel = 75, },
					[12] = { 1380, 1380, spellLevel = 80, },
		},
		[GetSpellInfo(34914)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Vampiric Touch",
					[0] = { School = "Shadow", eDot = true, bonusFactor = 2, eDuration = 15, sTicks = 3, },
					[1] = { 450, 450, spellLevel = 50, },
					[2] = { 600, 600, spellLevel = 60, },	
					[3] = { 650, 650, spellLevel = 70, },	
					[4] = { 735, 735, spellLevel = 75, },	
					[5] = { 850, 850, spellLevel = 80, },	
		},
		[GetSpellInfo(32379)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Shadow Word: Death",
					[0] = { School = "Shadow", canCrit = true, Cooldown = 12, },
					[1] = { 450, 522, spellLevel = 62, },
					[2] = { 572, 664, spellLevel = 70, },		
					[3] = { 639, 741, spellLevel = 75, },
					[4] = { 750, 870, spellLevel = 80, },				
		},
		[GetSpellInfo(8092)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Mind Blast",
					[0] = { School = "Shadow", canCrit = true, Cooldown = 8, BaseIncrease = true, },
					[1] = { 39, 43, 42, 42, spellLevel = 10, },
					[2] = { 72, 78, 57, 58, spellLevel = 16, },
					[3] = { 112, 120, 63, 64, spellLevel = 22, },
					[4] = { 167, 177, 72, 73, spellLevel = 28, },
					[5] = { 217, 231, 73, 74, spellLevel = 34, },
					[6] = { 279, 297, 76, 76, spellLevel = 40, },
					[7] = { 346, 366, 71, 72, spellLevel = 46, },
					[8] = { 425, 449, 67, 68, spellLevel = 52, },
					[9] = { 503, 531, 57, 58, spellLevel = 58, },
					[10] = { 557, 587, 49, 50, spellLevel = 63, },
					[11] = { 708, 748, 35, 36, spellLevel = 69, },
					[12] = { 837, 883, 24, 24, spellLevel = 74, },
					[13] = { 992, 1048, 5, 5, spellLevel = 79, },
		},
		[GetSpellInfo(17)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Power Word: Shield",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 4, NoDPS = true, NoDebuffs = true, NoDoom = true, BaseIncrease = true, NoSchoolTalents = true, NoTypeTalents = true },
					[1] = { 44, 44, 59, 59, spellLevel = 6, },
					[2] = { 88, 88, 81, 81, spellLevel = 12, },
					[3] = { 158, 158, 99, 99, spellLevel = 18, },
					[4] = { 234, 234, 112, 112, spellLevel = 24, },
					[5] = { 301, 301, 115, 115, spellLevel = 30, },
					[6] = { 381, 381, 114, 114, spellLevel = 36, },
					[7] = { 484, 484, 114, 114, spellLevel = 42, },
					[8] = { 605, 605, 108, 108, spellLevel = 48, },
					[9] = { 763, 763, 101, 101, spellLevel = 54, },
					[10] = { 942, 942, 86, 86, spellLevel = 60, },
					[11] = { 1125, 1125, 70, 70, spellLevel = 65, },
					[12] = { 1265, 1265, 51, 51, spellLevel = 70, },
					[13] = { 1920, 1920, 38, 38, spellLevel = 75, },
					[14] = { 2230, 2230, 0, 0, spellLevel = 80, },
		},
		[GetSpellInfo(2054)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, BaseIncrease = true,  },
					[1] = { 295, 341, 153, 154, spellLevel = 16, },
					[2] = { 429, 491, 185, 186, spellLevel = 22, },
					[3] = { 566, 642, 208, 208, spellLevel = 28, },
					[4] = { 712, 804, 207, 207, spellLevel = 34, },
		},
		[GetSpellInfo(2050)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Lesser Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 2.5, BaseIncrease = true, },
					[1] = { 46, 56, 71, 72, spellLevel = 1, castTime = 1.5, },
					[2] = { 71, 85, 83, 84, spellLevel = 4, castTime = 2, },
					[3] = { 135, 157, 112, 112, spellLevel = 10, },			
		},			
		[GetSpellInfo(2060)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Greater Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, BaseIncrease = true, },
					[1] = { 899, 1013, 204, 204, spellLevel = 40, },
					[2] = { 1149, 1289, 197, 198, spellLevel = 46, },
					[3] = { 1437, 1609, 184, 185, spellLevel = 52, },
					[4] = { 1798, 2006, 165, 165, spellLevel = 58, },
					[5] = { 1966, 2194, 162, 162, spellLevel = 60, },
					[6] = { 2074, 2410, 142, 143, spellLevel = 63, },
					[7] = { 2396, 2784, 111, 112, spellLevel = 68, },
					[8] = { 3395, 3945, 92, 93, spellLevel = 73, },
					[9] = { 3950, 4590, 30, 31, spellLevel = 78, },			
		},
		[GetSpellInfo(596)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Prayer of Healing",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, castTime = 3, bonusFactor = 0.2798, BaseIncrease = true, },
					[1] = { 301, 321, 65, 65, spellLevel = 30, },
					[2] = { 444, 472, 64, 64, spellLevel = 40, },
					[3] = { 657, 695, 60, 60, spellLevel = 50, },
					[4] = { 939, 991, 48, 48, spellLevel = 60, },
					[5] = { 997, 1053, 50, 50, spellLevel = 60, },
					[6] = { 1246, 1316, 33, 34, spellLevel = 68, },
					[7] = { 2091, 2209, 18, 20, spellLevel = 76, },
		},
		[GetSpellInfo(34861)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Circle of Healing",
					[0] = { School = { "Holy", "Healing" }, sFactor = 0.5, canCrit = true, BaseIncrease = true },
					[1] = { 343, 379, 30, 30, spellLevel = 50, },
					[2] = { 403, 445, 28, 29, spellLevel = 56, },
					[3] = { 458, 506, 28, 28, spellLevel = 60, },
					[4] = { 518, 572, 24, 24, spellLevel = 65, },
					[5] = { 572, 632, 18, 18, spellLevel = 70, },
					[6] = { 825, 911, 10, 10, spellLevel = 75, },
					[7] = { 958, 1058, 0, 0, spellLevel = 80, },
		},	
		[GetSpellInfo(2061)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Flash Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, BaseIncrease = true,  },
					[1] = { 193, 237, 114, 114, spellLevel = 20, },
					[2] = { 258, 314, 118, 119, spellLevel = 26, },
					[3] = { 327, 393, 120, 120, spellLevel = 32, },
					[4] = { 400, 478, 117, 118, spellLevel = 38, },
					[5] = { 518, 616, 118, 119, spellLevel = 44, },
					[6] = { 644, 764, 111, 111, spellLevel = 52, },
					[7] = { 812, 958, 100, 101, spellLevel = 58, },
					[8] = { 913, 1059, 89, 90, spellLevel = 61, },
					[9] = { 1101, 1279, 67, 68, spellLevel = 67, },
					[10] = { 1578, 1832, 56, 56, spellLevel = 73, },
					[11] = { 1887, 2193, 9, 10, spellLevel = 79, },
		},
		[GetSpellInfo(19236)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Desperate Prayer",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, Cooldown = 120, NoDoom = true, BaseIncrease = true },
					[1] = { 263, 325, 0, 0, spellLevel = 20, },
					[2] = { 447, 543, 0, 0, spellLevel = 26, },
					[3] = { 588, 708, 0, 0, spellLevel = 34, },
					[4] = { 834, 994, 38, 39, spellLevel = 42, }, -- 872-1033 in-game
					[5] = { 1101, 1305, 0, 0, spellLevel = 50, },
					[6] = { 1324, 1562, 0, 0, spellLevel = 58, },
					[7] = { 1601, 1887, 0, 0, spellLevel = 66, },
					[8] = { 3111, 3699, 0, 0, spellLevel = 73, },
					[9] = { 3716, 4384, 0, 0, spellLevel = 80, },
		},		
		[GetSpellInfo(139)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Renew",
					[0] = { School = { "Holy", "Healing" }, eDot = true, eDuration = 15, sTicks = 3, },
					[1] = { 45, 45, spellLevel = 8, },
					[2] = { 100, 100, spellLevel = 14, },
					[3] = { 175, 175, spellLevel = 20, },
					[4] = { 245, 245, spellLevel = 26, },
					[5] = { 315, 315, spellLevel = 32, },
					[6] = { 400, 400, spellLevel = 38, },
					[7] = { 510, 510, spellLevel = 44, },
					[8] = { 650, 650, spellLevel = 50, },
					[9] = { 810, 810, spellLevel = 56, },
					[10] = { 970, 970, spellLevel = 60, },
					[11] = { 1010, 1010, spellLevel = 65, },
					[12] = { 1110, 1110, spellLevel = 70, },
					[13] = { 1235, 1235, spellLevel = 75, },
					[14] = { 1400, 1400, spellLevel = 80, },
		},
		[GetSpellInfo(32546)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Binding Heal",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, BaseIncrease = true, },
					[1] = { 1042, 1338, 30, 31, spellLevel = 64, }, 
					[2] = { 1619, 2081, 24, 24, spellLevel = 72, },
					[3] = { 1952, 2508, 7, 8, spellLevel = 78, },
		},
		[GetSpellInfo(33076)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Prayer of Mending",
					[0] = { School = { "Holy", "Healing" }, canCrit = true, Cooldown = 10, sHits = 5, sFactor = 5, NoDPS = true },
					[1] = { 800, 800, spellLevel = 68, },
					[2] = { 905, 905, spellLevel = 74, },
					[3] = { 1043, 1043, spellLevel = 79, },
		},			
		[GetSpellInfo(585)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Smite",
					[0] = { School = "Holy", canCrit = true, castTime = 2.5, BaseIncrease = true, },
					[1] = { 13, 17, 39, 40, spellLevel = 1, castTime = 1.5, },
					[2] = { 25, 31, 44, 45,  spellLevel = 6, castTime = 2.0, },
					[3] = { 54, 62, 59, 60, spellLevel = 14, },
					[4] = { 91, 105, 75, 76, spellLevel = 22, },
					[5] = { 150, 170, 80, 80, spellLevel = 30, },
					[6] = { 212, 240, 84, 84, spellLevel = 38, },
					[7] = { 287, 323, 78, 79, spellLevel = 46, },
					[8] = { 371, 415, 70, 71, spellLevel = 54, },
					[9] = { 405, 453, 64, 65, spellLevel = 61, },
					[10] = { 545, 611, 45, 46, spellLevel = 69, },
					[11] = { 604, 676, 30, 30, spellLevel = 74, },					
					[12] = { 707, 793, 6, 6, spellLevel = 79, },					
		},
		[GetSpellInfo(14914)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Holy Fire",
					[0] = { School = "Holy", canCrit = true, castTime = 2, Cooldown = 10, eDuration = 7, sTicks = 1, bonusFactor = 0.5711, dotFactor = 0.168, BaseIncrease = true,  },
					[1] = { 102, 128, 90, 90, hybridDotDmg= 21, spellLevel = 20, },
					[2] = { 137, 173, 95, 96, hybridDotDmg= 28, spellLevel = 24, },
					[3] = { 200, 252, 100, 100, hybridDotDmg= 42, spellLevel = 30, },
					[4] = { 267, 339, 96, 97, hybridDotDmg= 56, spellLevel = 36, },
					[5] = { 348, 440, 95, 95, hybridDotDmg= 70, spellLevel = 42, },
					[6] = { 430, 546, 92, 93, hybridDotDmg= 91, spellLevel = 48, },
					[7] = { 529, 671, 83, 84, hybridDotDmg= 112, spellLevel = 54, },
					[8] = { 639, 811, 68, 68, hybridDotDmg= 126, spellLevel = 60, },
					[9] = { 705, 895, 50, 51, hybridDotDmg= 147, spellLevel = 66, },
					[10] = { 732, 928, 32, 32, hybridDotDmg= 287, spellLevel = 72, },
					[11] = { 890, 1130, 10, 10, hybridDotDmg= 350, spellLevel = 78, },				
		},
		[GetSpellInfo(15237)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Holy Nova",
					[0] = { School = { "Holy", "Healing", "Holy Nova Heal" }, canCrit = true, bonusFactor = 0.1606, BaseIncrease = true, },
					[1] = { 52, 60, 2, 3, spellLevel = 20, },
					[2] = { 86, 98, 3, 3, spellLevel = 28, },
					[3] = { 121, 139, 3, 4, spellLevel = 36, },
					[4] = { 161, 188, 4, 4, spellLevel = 44, },
					[5] = { 235, 272, 4, 4, spellLevel = 52, },
					[6] = { 302, 350, 5, 6, spellLevel = 60, },
					[7] = { 384, 446, 6, 6, spellLevel = 68, },
					[8] = { 611, 709, 6, 7, spellLevel = 75, },
					[9] = { 713, 827, 0, 0, spellLevel = 80, },
			["Secondary"] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Holy Nova",
					[0] = { School = { "Holy", "Holy Nova Damage" }, canCrit = true, bonusFactor = 0.1606, BaseIncrease = true, },
					[1] = { 28, 32, 1, 2, spellLevel = 20, },
					[2] = { 50, 58, 2, 3, spellLevel = 28, },
					[3] = { 76, 88, 3, 4, spellLevel = 36, },
					[4] = { 106, 123, 4, 4, spellLevel = 44, },
					[5] = { 140, 162, 6, 6, spellLevel = 52, },
					[6] = { 181, 210, 7, 7, spellLevel = 60, },
					[7] = { 242, 280, 8, 9, spellLevel = 68, },
					[8] = { 333, 387, 8, 8, spellLevel = 75, },
					[9] = { 398, 462, 0, 0, spellLevel = 80, },
			}
		},
		[GetSpellInfo(724)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Lightwell",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 180, bonusFactor = 1, eDot = true, eDuration = 6, sTicks = 2, Stacks = 10 },
					[1] = { 801, 801, spellLevel = 40, },
					[2] = { 1164, 1164, spellLevel = 50, },
					[3] = { 1599, 1599, spellLevel = 60, },
					[4] = { 2361, 2361, spellLevel = 70, },		
					[5] = { 3915, 3915, spellLevel = 75, },
					[6] = { 4620, 4620, spellLevel = 80, },					
		},
		[GetSpellInfo(64843)] = {
					--BASE OK, INCREASE OK, COEFFICIENT X
					["Name"] = "Divine Hymn",
					[0] = { School = { "Holy", "Healing" }, castTime = 8, sHits = 12, bonusFactor = 3.5, Channeled = true, canCrit = true },
					[1] = { 3024, 3342, spellLevel = 80 },
		},
		[GetSpellInfo(48045)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Mind Sear",
					[0] = { School = "Shadow", sHits = 5, castTime = 5, bonusFactor = 1.4305, Channeled = true },
					[1] = { 183, 197, spellLevel = 75},
					[2] = { 212, 228, spellLevel = 80},
		},
		[GetSpellInfo(53007)] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Penance",
					[0] = { School = { "Holy", "Healing" }, Cooldown = 12, canCrit = true, sHits = 3, castTime = 2, bonusFactor = 0.857, Channeled = true },
					[1] = { 670, 756, spellLevel = 60},
					[2] = { 805, 909, spellLevel = 70},
					[3] = { 1278, 1442, spellLevel = 75},
					[4] = { 1484, 1676, spellLevel = 80},
				["Secondary"] = {
					--DONE: BASE OK, INCREASE OK, COEFFICIENT OK
					["Name"] = "Penance",
					[0] = { School = "Holy", Cooldown = 12, canCrit = true, sHits = 3, castTime = 2, bonusFactor = 0.6876, Channeled = true },
					[1] = { 240, 240, spellLevel = 60},
					[2] = { 292, 292, spellLevel = 70},
					[3] = { 333, 333, spellLevel = 75},
					[4] = { 375, 375, spellLevel = 80},
				}
		},		
	}
	
	self.talentInfo = { 
		--SHADOW:
		--Darkness
		[GetSpellInfo(15259)] = { 	[1] = { Effect = 0.02, Spells = "Shadow" }, },
		--Shadow Focus
		[GetSpellInfo(15260)] = { 	[1] = { Effect = 1, Spells = "Shadow", ModType = "hitPerc" }, },
		--Improved Shadow Word: Pain
		[GetSpellInfo(15275)] = { 	[1] = { Effect = 0.03, Spells = "Shadow Word: Pain" }, },
		--Improved Mind Blast
		[GetSpellInfo(15273)] = { 	[1] = { Effect = -0.5, Spells = "Mind Blast", ModType = "cooldown" }, },
		--Mind Melt
		[GetSpellInfo(14910)] = {	[1] = { Effect = 2, Spells = { "Mind Blast", "Mind Flay", "Mind Sear" }, ModType = "critPerc", }, 
						[2] = { Effect = 3, Spells = { "Shadow Word: Pain", "Devouring Plague", "Vampiric Touch" } , ModType = "critPerc", }, },		
		--Improved Devouring Plague
		[GetSpellInfo(63625)] = {	[1] = { Effect = 0.05, Spells = "Devouring Plague" }, 
						[2] = { Effect = 0.05, Spells = "Devouring Plague", ModType = "Improved Devouring Plague", }, },		
		--Shadow Power
		[GetSpellInfo(33221)] = { 	[1] = { Effect = 0.1, Spells = { "Mind Blast", "Shadow Word: Death", "Mind Flay" }, ModType = "critM", }, },
		--Misery
		[GetSpellInfo(33191)] = {	[1] = { Effect = 0.05, Spells = { "Mind Blast", "Mind Flay", "Mind Sear" }, ModType = "SpellDamage", Multiply = true }, },
		--Twisted Faith
		[GetSpellInfo(47573)] = {	[1] = { Effect = 0.02, Spells = { "Mind Flay", "Mind Blast" }, ModType = "Twisted Faith" }, },					
		
		--HOLY:
		--Improved Renew
		[GetSpellInfo(14908)] = { 	[1] = { Effect = 0.05, Spells = "Renew" }, },
		--Searing Light
		[GetSpellInfo(14909)] = { 	[1] = { Effect = 0.05, Spells = { "Smite", "Holy Fire", "Penance", "Holy Nova Damage" } }, },
		--Spiritual Healing
		[GetSpellInfo(14898)] = {	[1] = { Effect = 0.02, Spells = "Healing" }, },
		--Empowered Healing
		[GetSpellInfo(33158)] = { 	[1] = { Effect = 0.08, Spells = "Greater Heal", ModType = "SpellDamage", Multiply = true },
						[2] = { Effect = 0.04, Spells = { "Flash Heal", "Binding Heal" }, ModType = "SpellDamage", Multiply = true }, },
		--Divine Providence
		[GetSpellInfo(47562)] = { 	[1] = { Effect = 0.02, Spells = { "Circle of Healing", "Binding Heal", "Divine Hymn", "Holy Nova Heal", "Prayer of Healing", "Prayer of Mending" } }, --Guessed ass additive, confirm?
						[2] = { Effect = -0.6, Spells = "Prayer of Mending", ModType = "cooldown" }, },
		--Empowered Renew
		[GetSpellInfo(63534)] = {	[1] = { Effect = 0.05, Spells = "Renew", ModType = "SpellDamage", Multiply = true, }, 
						[2] = { Effect = 0.05, Spells = "Renew", ModType = "Empowered Renew", }, },
		--Test of Faith
		[GetSpellInfo(47558)] = {	[1] = { Effect = 0.04, Spells = "Healing", ModType = "Test of Faith", }, },
		--Blessed Resilience
		[GetSpellInfo(33142)] = {	[1] = { Effect = 0.01, Spells = "Healing", Multiply = true, }, 
						[2] = { Effect = 0.01, Spells = { "Renew", "Lightwell" }, ModType = "Blessed Resilience" }, },
		
		--DISCIPLINE:
		--Improved Power Word: Shield (multiplicative?)
		[GetSpellInfo(14748)] = { 	[1] = { Effect = 0.05, Spells = "Power Word: Shield", }, },
		--Twin Disciplines
		[GetSpellInfo(47586)] = { 	[1] = { Effect = 0.01, Spells = { "Shadow Word: Pain", "Renew", "Power Word: Shield", "Holy Nova", "Prayer of Mending", "Devouring Plague", "Shadow Word: Death", "Desperate Prayer", "Circle of Healing" }  },
						[2] = { Effect = 0.01, Spells = "Renew", ModType = "Twin Disciplines" }, },
		--Focused Power
		[GetSpellInfo(33190)] = {	[1] = { Effect = 0.02, Spells = "All" }, 
						[2] = { Effect = 0.02, Spells = "Power Word: Shield", ModType = "Focused Power" }, },
		--Soul Warding
		[GetSpellInfo(63574)] = {	[1] = { Effect = -4, Spells = "Power Word: Shield", ModType = "cooldown" }, },
		--Improved Flash Heal
		[GetSpellInfo(63504)] = {	[1] = { Effect = { 4, 7, 10 }, Spells = "Flash Heal", ModType = "Improved Flash Heal" }, },
		--Renewed Hope
		[GetSpellInfo(57472)] = {	[1] = { Effect = 2, Spells = { "Flash Heal", "Greater Heal", "Penance" }, ModType = "Renewed Hope" }, },
		--Borrowed Time (additive?)
		[GetSpellInfo(52795)] = {	[1] = { Effect = 0.08, Spells = "Power Word: Shield", ModType = "SpellDamage" }, },
		--Divine Aegis
		[GetSpellInfo(47515)] = {	[1] = { Effect = 0.1, Spells = "Healing", ModType = "Divine Aegis", }, 
						[2] = { Effect = 0.1, Spells = "Power Word: Shield", ModType = "Divine Aegis Bonus" }, },	
		}
end